void * memmove(char * dst, char * src, size_t count)
{
        void * ret = dst;

        if (dst <= src || dst >= (src + count)) {
                /*
                 * Non-Overlapping Buffers
                 * copy from lower addresses to higher addresses
                 */
	        while (count>=4) {
	                *(long *)dst = *(long *)src;
	                dst+=4;
	                src+=4;
	                count-=4;
	        }

                while (count--)
                        *dst++ = *src++;
                }
        else {
                /*
                 * Overlapping Buffers
                 * copy from higher addresses to lower addresses
                 */
                dst += count;
                src += count;
/*
	        while (count>4) {
	        	dst-=4;
	                src-=4;
	                count-=4;
	                *(long *)dst = *(long *)src;
	        }
*/
                while (count--)
                        *--dst = *--src;

                }

        return(ret);
}

